/*************************************************************************************************
 * snatcher
 * Snatcher: Small and Simple Full-text Search System with Japanese - Version 2.3.1
 *                                                                              Mikio Hirabayashi
 *
 * 
 *    ʸΤΥǥåեꡢѤƸԤ
 *    礭櫓ơǥå⡼ɡԡץ⡼ɡ⡼ɡ¾Υ⡼ɤΣ̤ư
 *      ư򤷡Ϥ˥ץǵưѤ롣
 *
 * ǥ󥰥⡼
 *    ǥåϰʲν񼰤Ѥ롣ɸϤ˥Ϥ롣
 *         snatcher -index [-pp cmd] [-tp cmd] indexfile
 *    indexfile Ϻ륤ǥåեꤹ롣Υե뤬¸ߤϡ
 *      ͤɲä롣κݡƱեνʣɲäå뤳ȤϤʤ
 *    оݤΥե̾ɸϤγƹԤ롣ʸɤEUC-JPShift_JIS
 *      ISO-2022-JP졢EUC-JPѴƤϤ롣ԥɤLFľ
 *      ܸξϤιԤβԤ̵뤹롣ʸϥե͡롣
 *    -pp åꤵ줿硢ϥեƤľΰ˵Ҥ륳ޥɥ饤
 *      ѥפϤɸϤؤϤȤԤ
 *    -et åꤵ줿硢ϥեƤľΰ˵Ҥ륳ޥɥ饤
 *      ѥפϤɸϤʸΥȥȤϿ롣
 *
 * ɥեƥ󥰥⡼
 *    ե뤫鸡ǤФˤϰʲν񼰤Ѥ롣̤ɸϤγƹԤ˽Ϥ롣
 *         snatcher -draft [-pp cmd] [-score] [-sum] file ...
 *    -pp åϡǥåƱͤˡΥޥɥ饤ꤹ롣
 *    -score åϡǤΥ󥰷̤Ϥ롣
 *    -sum åϡʸϤ롣ǥåˤŤߤŤϹԤʤ
 *
 * ⡼
 *    ϰʲν񼰤Ѥ롣̤ɸϤγƹԤ˽Ϥ뤬Ȱפ륹
 *      ǤΥݥȤ򤽤θޤʸμпǳäͤιͤǹ߽˥Ȥ롣
 *         snatcher [-or] [-cap] [-val] [-tit] [-max num] [-key num]
 *                  [-asis] [-noscore] indexfile word ...
 *    word ϸоݤñꤹ뤬ʣϡ٤Ƥñޤե뤬Ф롣
 *    -or åϡñΤɤ줫ޤгȤưѹ롣
 *    -cap åϡƬԤϿʸȳȡβϷ̡ʸȳΥڥˤ
 *      ֶڤǽϤ롣
 *    -val åϡϤγƹԤ˸Ȱפ륹ιͤ򥿥ֶڤɲä롣
 *    -tit åϡϤγƹԤʸΥȥ򥿥ֶڤɲä롣ȥ뤬ʤ
 *      λݤ򼨤ʸѤ롣
 *    -max åϡϤκꤹ롣
 *    -key åϡϤγƹԤ˥ֶڤǥ˴ޤޤñɲäοꤹ롣
 *    -sum åϡϤγƹԤμιԤˡΥեϤ롣
 *      åղäƤʤ϶ԤϤ롣
 *    -asis åϡǲϤˤΤޤ޸ˤ롣
 *    -noscore åϡѤȤˤ륽ȤȥνϤ޻ߤ
 *       -val  -key ̵롣
 *
 * ¾⡼
 *    ʲν񼰤ǡΥץ˴ؤϤ롣
 *         snatcher [--files indexfile ] [--words indexfile] [--mksum indexfile]
 *                  [--help] [--version]
 *    --files åϡǥåե˴ޤޤեΰϤ롣
 *    --words åϡǥåե˴ޤޤñȤνи٤ΰϤ롣
 *    --mksum åϡǥåեγϿե򥤥ǥåղä롣
 *    --help åϡإ׾ɸϤ롣
 *    --version åϡСɸϤ롣
 *
 * ǡ١λ
 *    ǡ١ˤϤҤȤĤGDBMեѤ򤤤ĤΥ͡ॹڡʬ롣
 *     F Υ쥳ɡFIDޥˤͤϳǼեʣʿˤʸǤ롣
 *     F<X><X>ϣʿǥեIDˤΥ쥳ɷʥե륹ڡˤͤϤ
 *      եΥե̾ʸǤ롣
 *     W Υ쥳ɡWIDޥˤͤϳǼñʣʿˤʸǤ롣
 *     W<X><X>ϣʿñIDˤΥ쥳ɷñ쥹ڡˤͤϤñʸ
 *      Ǥ롣ñϥե뤫ФʸФChaSenѤƷǲϤˤΩ
 *      ȰŪ᤮̵̣ʵΤǤ롣
 *     T<X><X>ϣʿǥեIDˤΥ쥳ɷʥȥ륹ڡˤͤϤ
 *      եΥȥǤ롣ȥ -tp åΥޥɤˤä롣
 *     S<X><X>ϣʿǥեIDˤΥ쥳ɷʥڡˤͤϤΥ
 *      ΥοǤ롣ϡñIDȤñΥեˤݥȤ
 *      ߤ˸ȤƵϿ롣եˤݥȤȤϡñνи٤ˤ
 *      ݤˤΥեñμпǳäͤǤ롣եƬ
 *      餢˽Фñˤ٤ˤûƽŤߤŤԤޤȥ
 *      ˽иñˤϤ˽ŤߤŤԤ롣
 *     P<X><X>ϣʿǥեIDˤΥ쥳ɷʥץץåڡˤ
 *      ϤΥեϿ˻ѤץץåʸǤ롣ϿޥɤγƼ¹
 *      ˤǽΥեФƤΥ쥳ɤϵϿʤ
 *     A<X><X>ϣʿǥեIDˤΥ쥳ɷ󥹥ڡˤͤϤΥե
 *      ʸǤ롣ϡޤʸƬθ롣ˡξ̸
 *      ꡢʸοǳäФȤ
 *      βԤä롣ΥФƱͤñνи٤ȤäƽŤߤ
 *      Ԥ
 *     K<X><X>ϣʿǥեIDˤΥ쥳ɷʥɥڡˤͤϡ
 *      η̤Ȥƺ줿ɤʸ򥿥ֶڤ󤷤Ǥ롣
 *    ¾ʸΥ쥳ɷʥڡˤñʸ򥭡˻ͤϡƬ
 *      ˤñIDμϤñޤեΥեID󤷤ͤ˻
 *      ġ˸ASCIIαʸϾʸѴ롣
 *************************************************************************************************/


/* ⥸塼μ */
#include "easy.h"                           /* ꥸʥɸ饤֥ */
#include "aqua.h"                           /* ꥸʥGDBM¸饤֥ */
#include <chasen.h>                         /* ǲϡChaSenˤΥ饤֥ */
#include <unistd.h>                         /* UNIXɸإå */
#include <sys/types.h>                      /* ϰ¸̾إå */
#include <sys/stat.h>                       /* statؿΥإå */


/* ޥ */
#define PROGVERSION "snatcher-2.3.1"        /* ץΥС */
#define PROGYEAR    "2000-2002"             /* ץǯ */
#define PROGAUTHOR  "Mikio Hirabayashi"     /* ץ */
#define MAXTAILARGS 32                      /* Ѹİɤ߹ߺ */
#define NAMEBUFSIZ  1024                    /* ޥɤȥե̾ΥХåե */
#define DIAMMIN     2.0                     /* пκ */
#define INITPOINT   100                     /* ٿΥ */
#define TOPICBONUS  300                     /* ȥԥåνХؤβ */
#define TOPICRATE   5                       /* ȥԥåƬɴʬΨ */
#define TITLEBONUS  100                     /* ȥ˴ޤޤβ */
#define THRESPOINT  25                      /* Ͽκ */
#define SUMTOPNUM   48                      /* ʸƬ */
#define SUMKEYNUM   4                       /* ǥѤ */
#define SUMTEXTNUM  6                       /* ǥե졼п */
#define SUMHEADNUM  12                      /* ǳ줫̤ */
#define SUMTAILNUM  12                      /* ǳ줫ɤ */
#define MAXKEYWORDS 32                      /* Ͽκ */
#define TRUNCFREQ   64                      /* եϿDBƹۤ뤫 */
#define SSORTTHRES  0.1                     /* 쥯󥽡ȺѤγ */
#define NOTITLESTR  "(no title)"            /* ȥ뤬ʤʸ */


/*  */
typedef struct {                            /* ñ쥹ι¤η */
  const char *word;                         /* ñ */
  int score;                                /*  */
} SCORE;
typedef struct {                            /* ե륹ι¤η */
  int fid;                                  /* եID */
  int score;                                /*  */
  int aidx;                                 /* ź */
} FSCORE;


/* Хѿ */
int rv = 0;                                 /* λ */
char *dbname = NULL;                        /* ǡ١ե */
char *tails[MAXTAILARGS];                   /* Ѹİ */
int tnum = 0;                               /* Ѹİǿ */
int filesmode = FALSE;                      /* եꥹɽ⡼ɤΥå */
int wordsmode = FALSE;                      /* ñꥹɽ⡼ɤΥå */
int mksummode = FALSE;                      /* ⡼ɤΥå */
int helpmode = FALSE;                       /* إɽ⡼ɤΥå */
int versionmode = FALSE;                    /* Сɽ⡼ɤΥå */
int indexmode = FALSE;                      /* ǥ󥰥⡼ɤΥå */
int draftmode = FALSE;                      /* ɥեƥ󥰥⡼ɤΥå */
char *ppcmd = NULL;                         /* ץץåΥޥ */
char *tpcmd = NULL;                         /* ȥФΥޥ */
int summode = FALSE;                        /* ⡼ɤΥå */
int scoremode = FALSE;                      /* ɽ⡼ɤΥå */
int ormode = FALSE;                         /* ѥ⡼ɤΥå */
int capmode = FALSE;                        /* ɽ⡼ɤΥå */
int valmode = FALSE;                        /* ɽ⡼ɤΥå */
int titmode = FALSE;                        /* ȥɽ⡼ɤΥå */
int maxnum = 0;                             /* ɽ */
int keynum = 0;                             /* ɤɽ */
int asismode = FALSE;                       /* ϥ⡼ɤΥå */
int noscoremode = FALSE;                    /* ⡼ɤΥå */


/* ؿץȥ */
int main(int argc, char **argv);
void usage(FILE *OUT, int end);
void showerror(const char *format, ...);
char *gettext(const char *file);
char *gettitle(const char *file);
char *normalize(char *str);
EZCONT *getwords(const char *str, int original);
SCORE *getscores(EZCONT *words, EZCONT *twords, int *sp);
int scorecompare(const void *a, const void *b);
char *getsummary(const char *str, SCORE *scores, int snum, EZCONT *keywords);
void runindexingmode(void);
int registfile(const char *file);
void rundraftingmode(void);
void runsearchmode(void);
void showresult(int *res, int rnum, EZCONT *words, int *wids, double *diams);
int fscorecompare(const void *a, const void *b);
void fscoreselsort(FSCORE *fscores, int fnum);
void runfilesmode(void);
void runwordsmode(void);
void runmksummode(void);


/* ᥤ롼 */
int main(int argc, char **argv){
  int i;
  ezprogname = argv[0];
  for(i = 1; i < argc; i++){
    if(!dbname && argv[i][0] == '-'){
      if(!strcmp(argv[i], "--files")){
        filesmode = TRUE;
      } else if(!strcmp(argv[i], "--words")){
        wordsmode = TRUE;
      } else if(!strcmp(argv[i], "--mksum")){
        mksummode = TRUE;
      } else if(!strcmp(argv[i], "--help")){
        helpmode = TRUE;
      } else if(!strcmp(argv[i], "--version")){
        versionmode = TRUE;
      } else if(!strcmp(argv[i], "-index")){
        indexmode = TRUE;
      } else if(!strcmp(argv[i], "-draft")){
        draftmode = TRUE;
      } else if(!strcmp(argv[i], "-pp")){
        if(++i >= argc) usage(stderr, TRUE);
        ppcmd = argv[i];
      } else if(!strcmp(argv[i], "-tp")){
        if(++i >= argc) usage(stderr, TRUE);
        tpcmd = argv[i];
      } else if(!strcmp(argv[i], "-sum")){
        summode = TRUE;
      } else if(!strcmp(argv[i], "-score")){
        scoremode = TRUE;
      } else if(!strcmp(argv[i], "-or")){
        ormode = TRUE;
      } else if(!strcmp(argv[i], "-cap")){
        capmode = TRUE;
      } else if(!strcmp(argv[i], "-val")){
        valmode = TRUE;
      } else if(!strcmp(argv[i], "-tit")){
        titmode = TRUE;
      } else if(!strcmp(argv[i], "-max")){
        if(++i >= argc || !ezstrpure(argv[i], "0123456789")) usage(stderr, TRUE);
        maxnum = atoi(argv[i]);
      } else if(!strcmp(argv[i], "-key")){
        if(++i >= argc || !ezstrpure(argv[i], "0123456789")) usage(stderr, TRUE);
        keynum = atoi(argv[i]);
      } else if(!strcmp(argv[i], "-asis")){
        asismode = TRUE;
      } else if(!strcmp(argv[i], "-noscore")){
        noscoremode = TRUE;
      } else {
        usage(stderr, TRUE);
      }
    } else if(!dbname && !draftmode){
      dbname = argv[i];
    } else if(tnum < MAXTAILARGS){
      tails[tnum++] = argv[i];
    }
  }
  if(filesmode){
    if(!dbname) usage(stderr, TRUE);
    runfilesmode();
  } else if(wordsmode){
    if(!dbname) usage(stderr, TRUE);
    runwordsmode();
  } else if(mksummode){
    if(!dbname) usage(stderr, TRUE);
    runmksummode();
  } else if(helpmode){
    usage(stdout, 0);
  } else if(versionmode){
    printf("%s\nCopyright (C) %s %s\n", PROGVERSION, PROGYEAR, PROGAUTHOR);
  } else if(indexmode){
    if(!dbname) usage(stderr, TRUE);
    runindexingmode();
  } else if(draftmode){
    if(tnum < 1) usage(stderr, TRUE);
    rundraftingmode();
  } else {
    if(!dbname || tnum < 1) usage(stderr, TRUE);
    runsearchmode();
  }
  return rv;
}


/* ˡåϤend ʤ齪λ */
void usage(FILE *OUT, int end){
  fprintf(OUT, "%s: a full-text search system.\n", ezprogname);
  fprintf(OUT, "\n");
  fprintf(OUT, "INDEXING MODE: make an index file and registers files read from stdin.\n");
  fprintf(OUT, "  %s -index [options] indexfile\n", ezprogname);
  fprintf(OUT, "     -pp cmd   apply preprocessing with the following command line.\n");
  fprintf(OUT, "     -tp cmd   extract title with the following command line.\n");
  fprintf(OUT, "\n");
  fprintf(OUT, "DRAFTING MODE: draft words from files.\n");
  fprintf(OUT, "  %s -draft [options] file ...\n", ezprogname);
  fprintf(OUT, "     -pp cmd   appliy preprocessing with the following command line.\n");
  fprintf(OUT, "     -score    print keywords and its scoring points.\n");
  fprintf(OUT, "     -sum      print lame summary of documents.\n");
  fprintf(OUT, "\n");
  fprintf(OUT, "SEARCH MODE: search an index file for files including words.\n");
  fprintf(OUT, "  %s [options] indexfile word ...\n", ezprogname);
  fprintf(OUT, "     -or       count hits if they have any word of assigned ones.\n");
  fprintf(OUT, "     -cap      print search report at the first line.\n");
  fprintf(OUT, "     -val      print value of integrating score at the end of each hit.\n");
  fprintf(OUT, "     -tit      print title of the document at the end of each hit.\n");
  fprintf(OUT, "     -max num  limit max number of hits with the following number.\n");
  fprintf(OUT, "     -key num  print the following number of keywords.\n");
  fprintf(OUT, "     -sum      print summary at the next line of each hit.\n");
  fprintf(OUT, "     -asis     do not apply morphological analysis for searching words.\n");
  fprintf(OUT, "     -noscore  do not apply scoring and sorting for output.\n");
  fprintf(OUT, "\n");
  fprintf(OUT, "OTHER MODES: display information assigned by one of below options.\n");
  fprintf(OUT, "  %s [option]\n", ezprogname);
  fprintf(OUT, "     --files indexfile  print list of all registered files.\n");
  fprintf(OUT, "     --words indexfile  print list of all registered words.\n");
  fprintf(OUT, "     --mksum indexfile  record summary of documents into the index.\n");
  fprintf(OUT, "     --help             print this help message.\n");
  fprintf(OUT, "     --version          print the version infomation.\n");
  fprintf(OUT, "\n");
  if(end) exit(1);
}


/* 顼åϤ顼ɤꤹ */
void showerror(const char *format, ...){
  va_list ap;
  va_start(ap, format);
  fprintf(stderr, "%s: ", ezprogname);
  vfprintf(stderr, format, ap);
  fputc('\n', stderr);
  rv = 1;
  va_end(ap);
}


/* ե뤫ǡɤ߹ߡȤʸ֤顼ʤ NULL ֤ */
char *gettext(const char *file){
  FILE *IN;
  char *str, combuf[NAMEBUFSIZ];
  int size;
  struct stat sbuf;
  errno = 0;
  if(stat(file, &sbuf) == -1){
    if(errno == EACCES){
      showerror("%s: permission denied", file);
    } else {
      showerror("%s: no such file", file);
    }
    return NULL;
  }
  if(S_ISDIR(sbuf.st_mode)){
    showerror("%s: omitting directory", file);
    return NULL;
  }
  if(ppcmd){
    sprintf(combuf, "cat %s | %s", file, ppcmd);
    if(!(IN = popen(combuf, "r"))){
      showerror("%s: cannot execute", combuf);
      return NULL;
    }
    str = ezreadstream(IN, &size);
    pclose(IN);
    if(!str || size < 1){
      free(str);
      showerror("%s: empty data", combuf);
      return NULL;
    }
  } else {
    if(!(IN = fopen(file, "r"))){
      showerror("%s: cannot read", file);
      return NULL;
    }
    str = ezreadstream(IN, &size);
    fclose(IN);
    if(!str || size < 1){
      free(str);
      showerror("%s: empty file", file);
      return NULL;
    }
  }
  if(!(str = normalize(str))){
    free(str);
    showerror("%s: charcter code error", file);
    return NULL;
  }
  return str;
}


/* ե뤫ǡɤ߹ߡȤȥʸ֤顼ʤ NULL ֤ */
char *gettitle(const char *file){
  FILE *IN;
  char *str, combuf[NAMEBUFSIZ];
  int size;
  if(!tpcmd) return NULL;
  sprintf(combuf, "cat %s | %s", file, tpcmd);
  if(!(IN = popen(combuf, "r"))){
    showerror("%s: cannot execute", combuf);
    return NULL;
  }
  str = ezreadstream(IN, &size);
  pclose(IN);
  if(!str || size < 1){
    free(str);
    return NULL;
  }
  if(!(str = normalize(str))){
    free(str);
    showerror("%s: charcter code error", file);
    return NULL;
  }
  ezstrchop(str);
  ezascpurify(str, ' ', "");
  return str;
}


/* ʸɤEUC-JPľԥɤLFľ */
char *normalize(char *str){
  char *esc;
  switch(ezcharcode(str)){
  case EZ_CASCII:
    break;
  case EZ_CEUC:
    break;
  case EZ_CJUNET:
    esc = ezjunettoeuc(str);
    free(str);
    str = esc;
    break;
  case EZ_CSJIS:
    esc = ezsjistoeuc(str);
    free(str);
    str = esc;
    break;
  case EZ_CERR:
    free(str);
    return NULL;
  }
  esc = ezlineescape(str, EZ_LUNIX);
  free(str);
  return esc;
}


/* ǲϤ̤򥳥ƥʤ˳Ǽ֤
   original ʤƤñޤߡǤʤйʤߤԤ */
EZCONT *getwords(const char *str, int original){
  char *chabase[] = { "chasen", "-F" "%M\\t%H\\t%P2-\\n", NULL };  /* 䦤δܷץ */
  char *chaorig[] = { "chasen", "-F" "%m\\t%H\\t%P2-\\n", NULL };  /* 䦤νиץ */
  char *taboo[] = {                                                /* ̶ػ߸ */
    "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "ޤ", "", "", "", "", "Ĥ", "Ĥ",
    "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "٤",
    "", "", "", "", "", "", "", "", "", "", "",
    "Ĥ", "Ĥ", "Ť","Ť", "Ť", "Ǥ", "Ǥ", "Ǥ", "Ȥ", "Ȥ", "ɤ",
    "ɤ", "ɤ", "ɤ", "ʤ", "ʤ", "ʤ", "ʤ", "ʤ", "Ҥ", "Ҥ", "ۤ",
    "ۤ", "ޤ", "ޤ", "ޤ", "ޤ", "ޤ", "ߤʤ", "ߤ", "ä", "", "",
    "", "", "褤", "褦", "", "", "", "櫓", "뤤", "", "",
    "a", "all", "am", "an", "and", "any", "are", "as", "at", "be", "but", "by", "can", "could",
    "did", "do", "does", "done", "either", "even", "every", "for", "from", "he", "her", "him",
    "his", "how", "however", "i", "if", "in", "into", "is", "it", "its", "many", "may",
    "me", "might", "more", "most", "mr", "ms", "much", "must", "my", "never", "no", "none",
    "not", "of", "on", "one", "onto", "or", "othrwise", "shall", "she", "should", "so",
    "some", "such", "than", "that", "the", "their", "them", "then", "these", "they", "thing",
    "things", "this", "those", "to", "via", "was", "we", "were", "when", "where", "which",
    "who", "whom", "whose", "will", "with", "without", "would", "you", "your",
    "#", "##", "####", "--", "---", "----", "..", "...", "....", "//", "///", "////", NULL
  };
  int capmax = 30;                                                 /* ץ󰷤η */
  int minwordlen = 2;                                              /* ñκǾХȿ */
  int maxwordlen = 32;                                             /* ñκХȿ */
  char *vetochars = "\"#$'^|\\{}*`[]<>(){}";                       /* ػʸ */
  char *markchars = ",:;.?!%=~+-*_/@[]<>(){}\"'`";                 /* ʸ */
  char *pathheads = ":./@";                                        /* ѥƬ˴ޤʸ */
  char *pathtails = "/";                                           /* ѥ˴ޤʸ */
  int markmax = 16;                                                /* ʸνиƿ */
  int maxlinelen = 2048;                                           /* ԤκĹ */
  static EZCONT *taboocont = NULL;                                 /* ̶ػ߸ѥƥ */
  EZCONT *cont;
  unsigned char *esc, *fesc, *wp;
  char *buf, *line, *index, *elems[3];
  int i, ja, len;
  if(!taboocont){
    taboocont = eznewcont();
    for(i = 0; taboo[i]; i++){
      ezcontpush(taboocont, taboo[i]);
    }
    ezqsortcont(taboocont);
  }
  cont = eznewcont();
  if(original){
    chasen_getopt_argv(chaorig, NULL);
  } else {
    chasen_getopt_argv(chabase, NULL);
  }
  wp = esc = ezmalloc(strlen(str) + 1);
  ja = FALSE;
  for(i = 0, len = 0; str[i] != '\0'; i++, len++){
    if(!ja && i > 1 && str[i] == '\n' && str[i-1] == '-'){
      wp--;
      ja = TRUE;
    }
    if((str[i] != '\n' || !ja || len <= capmax) && !(ja && str[i] == ' ')) *(wp++) = str[i];
    if(str[i] == '\n') len = 0;
    ja = (unsigned char)str[i] > 0x7f || (ja && (str[i] == ' ' || str[i] == '\n'));
  }
  *wp = '\0';
  fesc = (unsigned char *)ezeuclinefold((char *)esc, maxlinelen);
  free(esc);
  buf = chasen_sparse_tostr((char *)fesc);
  free(fesc);
  index = buf;
  while((line = ezstrdiv(&index, "\n")) != NULL){
    if(ezsplit(line, "\t", elems, 3) != 3) continue;
    if(!original){
      if(strcmp(elems[1], "̤θ") && strcmp(elems[1], "̾") && strcmp(elems[1], "ư") &&
         strcmp(elems[1], "ƻ") && strcmp(elems[1], "ư") && strcmp(elems[1], "") &&
         strcmp(elems[1], "ư")) continue;
      if(!strcmp(elems[2], "ư-") || !strcmp(elems[2], "ư-Ω") ||
         !strcmp(elems[2], "̾-") || !strcmp(elems[2], "̾-Ω") ||
         !strcmp(elems[2], "̾-̾")) continue;
      len = strlen(elems[0]);
      if(strchr(markchars, elems[0][len-1]) && !strchr(pathtails, elems[0][len-1]))
        elems[0][len-1] = '\0';
      if(strchr(markchars, elems[0][0]) && !strchr(pathheads, elems[0][0])) elems[0] += 1;
      len = strlen(elems[0]);
      if(len < minwordlen || len > maxwordlen) continue;
      if(ezcntchr(elems[0], vetochars) > 0) continue;
      if(ezcntchr(elems[0], markchars) > markmax) continue;
      if(ezstrpure(elems[0], "0123456789-.:;/")) continue;
      ezstrlower(elems[0]);
      if(ezcontbsearch(taboocont, elems[0])) continue;
    }
    ezcontpush(cont, elems[0]);
  }
  return cont;
}


/* ʸñ줴Ȥ˥׻¤˳Ǽ֤ */
SCORE *getscores(EZCONT *words, EZCONT *twords, int *sp){
  SCORE *scores;
  int snum, i, j, hit, wi;
  double diam;
  scores = ezmalloc(ezcontsize(words) * sizeof(scores[0]));
  snum = 0;
  for(i = 0; i < ezcontsize(words); i++){
    hit = FALSE;
    for(j = 0; j < snum; j++){
      if(!strcmp(ezcontval(words, i), scores[j].word)){
        scores[j].score += INITPOINT;
        hit = TRUE;
      }
    }
    if(!hit){
      scores[snum].word = ezcontval(words, i);
      scores[snum].score = INITPOINT;
      if(i < ezcontsize(words) * (TOPICRATE / 100.0)) scores[snum].score += TOPICBONUS;
      snum++;
    }
  }
  if(twords) ezqsortcont(twords);
  diam = log(ezcontsize(words));
  diam = diam > DIAMMIN ? diam : DIAMMIN;
  wi = 0;
  for(i = 0; i < snum; i++){
    scores[i].score /= diam;
    if(twords && ezcontbsearch(twords, scores[i].word)) scores[i].score += TITLEBONUS;
    if(scores[i].score >= THRESPOINT){
      scores[wi].word = ezstrdup(scores[i].word);
      scores[wi].score = scores[i].score;
      wi++;
    }
  }
  *sp = wi;
  qsort(scores, wi, sizeof(scores[0]), scorecompare);
  return scores;
}


/* ¤ΤӴؿ */
int scorecompare(const void *a, const void *b){
  SCORE *ap, *bp;
  int v;
  ap = (SCORE *)a;
  bp = (SCORE *)b;
  if((v = ap->score - bp->score) != 0) return -v;
  return strcmp(ap->word, bp->word);
}


/* ʸʸ򥢥Ȥ֤
   newscores  NULL ǤʤСǥåξŤߤŤѤ
   ˥ɤǼ롣 */
char *getsummary(const char *str, SCORE *scores, int snum, EZCONT *keywords){
  char *markchars = ",:;.?!%=~+-*_/@[]<>(){}\"'`";          /* ʸ */
  int markmax = 8;                                          /* ʸνиƿ */
  int sumbias = 3;                                          /* ФФ */
  char *buf;
  const char *word;
  EZCONT *words;
  AQARRAY *arrays;
  int i, j, k, n, ja, miss, hit;
  double diam;
  if(keywords){
    words = eznewcont();
    for(i = 0; i < snum; i++){
      ezcontpush(words, scores[i].word);
    }
    if((arrays = aqdbsearcharrays(dbname, words)) != NULL){
      for(i = 0; i < ezcontsize(words); i++){
        if(arrays[i].array){
          diam = arrays[i].size > 1 ? log(arrays[i].size - 1) : 0.0;
          diam = diam > DIAMMIN ? diam : DIAMMIN;
          scores[i].score /= diam;
        } else {
          scores[i].score = 0;
        }
      }
      aqdbarraysfree(arrays, ezcontsize(words));
    }
    ezdelcont(words);
    qsort(scores, snum, sizeof(scores[0]), scorecompare);
    for(i = 0; i < snum && i < MAXKEYWORDS; i++){
      ezcontpush(keywords, scores[i].word);
    }
  }
  words = getwords(str, TRUE);
  buf = NULL;
  ja = TRUE;
  miss = 0;
  for(i = 0; i < ezcontsize(words) && i < SUMTOPNUM + miss; i++){
    word = ezcontval(words, i);
    if(ezcntchr(word, markchars) > markmax){
      miss++;
      continue;
    }
    buf = ezstrcat(buf, (!buf || (ja && word[0] < 0)) ? "" : " ", word, NULL);
    ja = (word[0] < 0);
  }
  buf = ezstrcat(buf, " ... ", NULL);
  n = 0;
  for(i += SUMHEADNUM; i < ezcontsize(words); i++){
    word = ezcontval(words, i);
    hit = FALSE;
    for(j = 0; j < snum && j < SUMKEYNUM; j++){
      if(!strcmp(word, scores[j].word)) hit = TRUE;
    }
    if(hit){
      ja = TRUE;
      miss = 0;
      for(k = i - SUMHEADNUM; k < ezcontsize(words) && k < i + SUMTAILNUM + miss; k++){
        word = ezcontval(words, k);
        if(ezcntchr(word, markchars) > markmax){
          miss++;
          continue;
        }
        buf = ezstrcat(buf, (ja && word[0] < 0) ? "" : " ", word, NULL);
        ja = (word[0] < 0);
      }
      buf = ezstrcat(buf, " ... ", NULL);
      n++;
      i = k + SUMHEADNUM + ezcontsize(words) / ((SUMTEXTNUM + 1) * sumbias);
    }
    if(n >= SUMTEXTNUM) break;
  }
  ezdelcont(words);
  return buf;
}


/* ǥ󥰥⡼ɤΥᥤؿ */
void runindexingmode(void){
  char *file;
  int num, be;
  time_t t;
  t = eztime();
  num = 0;
  be = FALSE;
  if(aqdbcapture(dbname, TRUE) == -1) showerror("database capturing failed");
  while((file = ezreaddiv(stdin, "\n")) != NULL){
    if(num > 0 && num % TRUNCFREQ == 0){
      if(aqdbreorganize(dbname) == -1) showerror("database rebuilding failed");
    }
    if(ezstrchop(file) > 0 && registfile(file)){
      num++;
      be = TRUE;
    }
    free(file);
  }
  if(be){
    if(aqdbreorganize(dbname) == -1) showerror("database rebuilding failed");
    t = eztime() - t;
    printf("%s: %02d:%02d:%02d elapsed\n",
           rv == 0 ? "completed" : "done", (int)(t / 3600), (int)((t / 60) % 60), (int)(t % 60));
  } else {
    showerror("nothing to do");
  }
  aqdbrelease();
}


/* ե򥤥ǥåϿݤ֤ */
int registfile(const char *file){
  static int first = TRUE;
  char *str, *buf, idstr[EZ_NUMBUFSIZ], **pairs, *title;
  EZCONT *words, *uwords, *nwords, *twords;
  EZMAP *map;
  SCORE *scores;
  int snum, fid, wid, i, *array, anum, *abuf, abnum;
  if(!(str = gettext(file))) return FALSE;
  title = gettitle(file);
  fid = 1;
  if((buf = aqdbsearch(dbname, "F")) != NULL){
    fid = strtol(buf, NULL, 16) + 1;
    free(buf);
  }
  sprintf(idstr, "%X", fid);
  if(aqdbwrite(dbname, "F", idstr, TRUE, NULL) == -1){
    showerror("writing database failed");
    free(str);
    return FALSE;
  }
  if(first){
    sprintf(idstr, "P%X", fid);
    if(aqdbwrite(dbname, idstr, ppcmd ? ppcmd : "", TRUE, NULL) == -1){
      showerror("writing database failed");
      free(str);
      return FALSE;
    }
    first = FALSE;
  }
  sprintf(idstr, "F%X", fid);
  if(aqdbwrite(dbname, idstr, file, TRUE, NULL) == -1){
    showerror("writing database failed");
    free(str);
    return FALSE;
  }
  words = getwords(str, FALSE);
  free(str);
  uwords = ezdupcont(words);
  ezuniqcont(uwords);
  wid = 1;
  if((buf = aqdbsearch(dbname, "W")) != NULL){
    wid = strtol(buf, NULL, 16) + 1;
    free(buf);
  }
  if(!(nwords = aqdbdiffcont(dbname, uwords, FALSE))) nwords = ezdupcont(uwords);
  pairs = ezmalloc((ezcontsize(nwords) * 2 + 1) * sizeof(pairs[0]));
  array = ezmalloc((ezcontsize(nwords)) * sizeof(array[0]));
  for(i = 0; i < ezcontsize(nwords); i++){
    pairs[i*2] = ezsprintf(NULL, "W%X", wid);
    pairs[i*2+1] = (char *)ezcontval(nwords, i);
    array[i] = wid;
    wid++;
  }
  pairs[i*2] = NULL;
  map = eznewmap();
  ezmapstore(map, (const char **)pairs);
  for(i = 0; i < ezcontsize(nwords); i++){
    free(pairs[i*2]);
  }
  free(pairs);
  sprintf(idstr, "%X", wid - 1);
  if(aqdbwritemap(dbname, map, TRUE, NULL) == -1 ||
     aqdbwritecontnum(dbname, nwords, array, TRUE, FALSE) == -1 ||
     aqdbwrite(dbname, "W", idstr, TRUE, NULL) == -1){
    showerror("writing database failed");
    ezdelcont(words);
    ezdelcont(uwords);
    ezdelcont(nwords);
    ezdelmap(map);
    free(array);
  }
  ezdelcont(nwords);
  ezdelmap(map);
  free(array);
  array = ezmalloc(ezcontsize(uwords) * sizeof(array[0]));
  for(i = 0; i < ezcontsize(uwords); i++){
    array[i] = fid;
  }
  if(aqdbwritecontnum(dbname, uwords, array, TRUE, TRUE) == -1){
    showerror("writing database failed");
    ezdelcont(words);
    ezdelcont(uwords);
    free(array);
  }
  free(array);
  twords = NULL;
  if(title){
    twords = getwords(title, FALSE);
    sprintf(idstr, "T%X", fid);
    if(aqdbwrite(dbname, idstr, title, TRUE, NULL) == -1){
      showerror("writing database failed");
      free(title);
      ezdelcont(words);
      ezdelcont(twords);
      return FALSE;
    }
    free(title);
  }
  scores = getscores(words, twords, &snum);
  if(twords) ezdelcont(twords);
  array = ezmalloc(snum * 2 * sizeof(array[0]));
  anum = 0;
  for(i = 0; i < snum; i++){
    if(!(abuf = aqdbsearcharray(dbname, scores[i].word, &abnum))) continue;
    array[anum++] = abnum > 0 ? abuf[0] : 0;
    array[anum++] = scores[i].score;
    free(abuf);
  }
  sprintf(idstr, "S%X", fid);
  if(aqdbwritearray(dbname, idstr, array, anum, TRUE, FALSE) == -1){
    showerror("writing database failed");
    free(array);
    free(scores);
    ezdelcont(words);
    return FALSE;
  }
  free(array);
  printf("%d: %s: registered (%d words, %d keywords)\n", fid, file, ezcontsize(uwords), snum);
  fflush(stdout);
  free(scores);
  ezdelcont(uwords);
  ezdelcont(words);
  return TRUE;
}


/* ɥեƥ󥰥⡼ɤΥᥤؿ */
void rundraftingmode(void){
  int i, j, snum;
  char *str, *summary;
  EZCONT *words;
  SCORE *scores;
  for(i = 0; i < tnum; i++){
    if(!(str = gettext(tails[i]))) continue;
    words = getwords(str, FALSE);
    if(scoremode || summode){
      scores = getscores(words, NULL, &snum);
      if(summode){
        summary = getsummary(str, scores, snum, NULL);
        printf("%s\n", summary);
        free(summary);
      } else {
        for(j = 0; j < snum; j++){
          printf("%s\t%d\n", scores[j].word, scores[j].score);
        }
      }
      free(scores);
    } else {
      for(j = 0; j < ezcontsize(words); j++){
        printf("%s\n", ezcontval(words, j));
      }
    }
    ezdelcont(words);
    free(str);
  }
}


/* ⡼ɤΥᥤؿ */
void runsearchmode(void){
  struct stat sbuf;
  char *buf;
  int i, j, k, ok, be, **hits, *hnums, *res, rnum, *wids;
  double *diams;
  EZCONT *words;
  errno = 0;
  if(stat(dbname, &sbuf) == -1){
    if(errno == EACCES){
      showerror("%s: permission denied", dbname);
    } else {
      showerror("%s: no such file", dbname);
    }
    return;
  }
  if(S_ISDIR(sbuf.st_mode)){
    showerror("%s: omitting directory", dbname);
    return;
  }
  if(asismode){
    words = eznewcont();
    for(i = 0; i < tnum; i++){
      ezcontpush(words, tails[i]);
    }
  } else {
    buf = NULL;
    for(i = 0; i < tnum; i++){
      buf = ezsprintf(buf, "%s\n", tails[i]);
    }
    words = buf ? getwords(buf, FALSE) : eznewcont();
    free(buf);
  }
  if(ezcontsize(words) < 1){
    ezdelcont(words);
    showerror("no search key included");
    return;
  }
  hits = ezmalloc(ezcontsize(words) * sizeof(hits[0]));
  hnums = ezmalloc(ezcontsize(words) * sizeof(hnums[0]));
  rnum = 0;
  for(i = 0; i < ezcontsize(words); i++){
    if((hits[i] = aqdbsearcharray(dbname, ezcontval(words, i), hnums + i)) != NULL){
      rnum += hnums[i] - 1;
      if(hnums[i] < 2) hnums[i] = 0;
    } else {
      hnums[i] = 0;
    }
  }
  res = ezmalloc(rnum * sizeof(res[0]));
  rnum = 0;
  wids = ezmalloc(ezcontsize(words) * sizeof(wids[0]));
  diams = ezmalloc(ezcontsize(words) * sizeof(diams[0]));
  for(i = 0; i < ezcontsize(words); i++){
    wids[i] = hnums[i] > 0 ? hits[i][0] : 0;
    diams[i] = hnums[i] > 1 ? log(hnums[i] - 1) : 0.0;
    diams[i] = diams[i] > DIAMMIN ? diams[i] : DIAMMIN;
  }
  if(ormode){
    for(i = 0; i < ezcontsize(words); i++){
      for(j = 1; j < hnums[i]; j++){
        res[rnum++] = hits[i][j];
      }
    }
  } else {
    for(i = 1; i < hnums[0]; i++){
      ok = TRUE;
      for(j = 1; j < ezcontsize(words); j++){
        be = FALSE;
        for(k = 1; k < hnums[j]; k++){
          if(hits[0][i] == hits[j][k]){
            be = TRUE;
            break;
          }
        }
        if(!be) ok = FALSE;
      }
      if(ok) res[rnum++] = hits[0][i];
    }
  }
  ezuniqnums(res, &rnum);
  if(capmode){
    if(!(buf = aqdbsearch(dbname, "F"))) buf = ezstrdup("0");
    printf("%d\t%d", (int)strtol(buf, NULL, 16), rnum);
    free(buf);
    for(i = 0; i < ezcontsize(words); i++){
      printf("\t%s\t%d", ezcontval(words, i), hnums[i] > 1 ? hnums[i] - 1 : 0);
    }
    putchar('\n');
  }
  showresult(res, rnum, words, wids, diams);
  free(res);
  free(wids);
  free(diams);
  for(i = 0; i < ezcontsize(words); i++){
    free(hits[i]);
  }
  free(hits);
  free(hnums);
  ezdelcont(words);
}


/* ̤Ϥ */
void showresult(int *res, int rnum, EZCONT *words, int *wids, double *diams){
  char idstr[EZ_NUMBUFSIZ], *buf;
  EZCONT *cont, *keys, *vals;
  AQARRAY *arrays, *ap;
  FSCORE *fscores;
  int i, j, k;
  if(aqdbcapture(dbname, FALSE) == -1){
    showerror("%s: cannot open", dbname);
    return;
  }
  if(noscoremode){
    for(i = 0; i < rnum && (maxnum < 1 || i < maxnum); i++){
      sprintf(idstr, "F%X", res[i]);
      if((buf = aqdbsearch(dbname, idstr)) != NULL){
        printf("%s\n", buf);
        free(buf);
        if(summode){
          sprintf(idstr, "A%X", res[i]);
          if((buf = aqdbsearch(dbname, idstr)) != NULL){
            printf("%s\n", buf);
            free(buf);
          } else {
            putchar('\n');
          }
        }
      } else {
        showerror("search for %s failed", idstr);
      }
    }
  } else {
    cont = eznewcont();
    for(i = 0; i < rnum; i++){
      sprintf(idstr, "S%X", res[i]);
      ezcontpush(cont, idstr);
    }
    if(!(arrays = aqdbsearcharrays(dbname, cont))){
      ezdelcont(cont);
      showerror("cannot read scores");
      return;
    }
    fscores = ezmalloc(rnum * sizeof(fscores[0]));
    for(i = 0; i < rnum; i++){
      fscores[i].fid = res[i];
      fscores[i].score = 0;
      fscores[i].aidx = i;
      if(!arrays[i].array) continue;
      for(j = 0; j < ezcontsize(words); j++){
        for(k = 0; k < arrays[i].size; k += 2){
          if(arrays[i].array[k] == wids[j]){
            fscores[i].score += arrays[i].array[k+1] / diams[j];
          }
        }
      }
    }
    if(maxnum < 1 || maxnum > rnum * SSORTTHRES){
      qsort(fscores, rnum, sizeof(fscores[0]), fscorecompare);
    } else {
      fscoreselsort(fscores, rnum);
    }
    for(i = 0; i < rnum && (maxnum < 1 || i < maxnum); i++){
      sprintf(idstr, "F%X", fscores[i].fid);
      if((buf = aqdbsearch(dbname, idstr)) != NULL){
        printf("%s", buf);
        free(buf);
        if(valmode) printf("\t%d", fscores[i].score);
        if(titmode){
          sprintf(idstr, "T%X", fscores[i].fid);
          buf = aqdbsearch(dbname, idstr);
          printf("\t%s", buf ? buf : NOTITLESTR);
          free(buf);
        }
        if(keynum > 0){
          sprintf(idstr, "K%X", fscores[i].fid);
          if((buf = aqdbsearch(dbname, idstr)) != NULL){
            k = 0;
            for(j = 0; buf[j] != '\0'; j++){
              if(buf[j] == '\t') k++;
              if(k >= keynum){
                buf[j] = '\0';
                break;
              }
            }
            printf("\t%s", buf);
            free(buf);
          } else {
            ap = arrays + fscores[i].aidx;
            keys = eznewcont();
            for(j = 0; j < ap->size && j < keynum * 2; j += 2){
              sprintf(idstr, "W%X", ap->array[j]);
              ezcontpush(keys, idstr);
            }
            vals = aqdbsearchcont(dbname, keys);
            ezdelcont(keys);
            if(vals){
              for(j = 0; j < ezcontsize(vals); j++){
                printf("\t%s", ezcontval(vals, j));
              }
              ezdelcont(vals);
            }
          }
        }
        putchar('\n');
        if(summode){
          sprintf(idstr, "A%X", fscores[i].fid);
          if((buf = aqdbsearch(dbname, idstr)) != NULL){
            printf("%s\n", buf);
            free(buf);
          } else {
            putchar('\n');
          }
        }
      } else {
        showerror("search for %s failed", idstr);
      }
    }
    free(fscores);
    aqdbarraysfree(arrays, ezcontsize(cont));
    ezdelcont(cont);
  }
  if(rnum < 1) showerror("no match");
  aqdbrelease();
}


/* ¤ΤӴؿ */
int fscorecompare(const void *a, const void *b){
  FSCORE *ap, *bp;
  int v;
  ap = (FSCORE *)a;
  bp = (FSCORE *)b;
  if((v = bp->score - ap->score) != 0) return v;
  return bp->fid - ap->fid;
}


/* ¤Τξ򥽡 */
void fscoreselsort(FSCORE *fscores, int fnum){
  int i, j, bi, ti;
  FSCORE tmp;
  for(i = 0; i < fnum && i < maxnum; i++){
    bi = ti = i;
    for(j = bi; j < fnum; j++){
      if(fscores[j].score > fscores[ti].score ||
         (fscores[j].score == fscores[ti].score && fscores[j].fid > fscores[ti].fid)){
        ti = j;
      }
    }
    tmp = fscores[bi];
    fscores[bi] = fscores[ti];
    fscores[ti] = tmp;
  }
}


/* ϿեΥꥹȤϤ */
void runfilesmode(void){
  char idstr[EZ_NUMBUFSIZ], *buf;
  int fid, i;
  if(aqdbcapture(dbname, FALSE) == -1){
    showerror("%s: cannot open", dbname);
    return;
  }
  if((buf = aqdbsearch(dbname, "F")) != NULL){
    fid = strtol(buf, NULL, 16);
    free(buf);
  } else {
    showerror("no files registered");
    aqdbrelease();
    return;
  }
  for(i = 1; i <= fid; i++){
    sprintf(idstr, "F%X", i);
    if((buf = aqdbsearch(dbname, idstr)) != NULL){
      printf("%s\n", buf);
      free(buf);
    } else {
      showerror("search for %s failed", idstr);
    }
  }
  aqdbrelease();
}


/* ϿñΥꥹȤϤ */
void runwordsmode(void){
  char idstr[EZ_NUMBUFSIZ], *buf;
  int wid, i, *array, anum;
  if(aqdbcapture(dbname, FALSE) == -1){
    showerror("%s: cannot open", dbname);
    return;
  }
  if((buf = aqdbsearch(dbname, "W")) != NULL){
    wid = strtol(buf, NULL, 16);
    free(buf);
  } else {
    showerror("no files registered");
    aqdbrelease();
    return;
  }
  for(i = 1; i <= wid; i++){
    sprintf(idstr, "W%X", i);
    if((buf = aqdbsearch(dbname, idstr)) != NULL){
      printf("%s", buf);
      if((array = aqdbsearcharray(dbname, buf, &anum)) != NULL){
        printf("\t%d", anum);
        free(array);
      }
      putchar('\n');
      free(buf);
    } else {
      showerror("search for %s failed", idstr);
    }
  }
  aqdbrelease();
}


/* Ԥ */
void runmksummode(void){
  char idstr[EZ_NUMBUFSIZ], *buf, *str, *sum, *kbuf;
  int fid, i, snum, j;
  EZCONT *words, *kwords;
  SCORE *scores;
  time_t t;
  t = eztime();
  if((buf = aqdbsearch(dbname, "F")) != NULL){
    fid = strtol(buf, NULL, 16);
    free(buf);
  } else {
    showerror("no files registered");
    aqdbrelease();
    return;
  }
  if(aqdbcapture(dbname, TRUE) == -1) showerror("database capturing failed");
  printf("start: making summary of %d documents\n", fid);
  ppcmd = NULL;
  for(i = 1; i <= fid; i++){
    if(i > 1 && (i - 1) % TRUNCFREQ == 0){
      if(aqdbreorganize(dbname) == -1) showerror("database rebuilding failed");
    }
    sprintf(idstr, "P%X", i);
    if((buf = aqdbsearch(dbname, idstr)) != NULL){
      free(ppcmd);
      if(buf[0] == '\0'){
        free(buf);
        buf = NULL;
      }
      ppcmd = buf;
      printf("%d: changes the preprosessor to \"%s\"\n", i, buf ? buf : "(none)");
    }
    sprintf(idstr, "F%X", i);
    if((buf = aqdbsearch(dbname, idstr)) != NULL){
      if((str = gettext(buf)) != NULL){
        words = getwords(str, FALSE);
        scores = getscores(words, NULL, &snum);
        kwords = eznewcont();
        sum = getsummary(str, scores, snum, kwords);
        sprintf(idstr, "A%X", i);
        if(aqdbwrite(dbname, idstr, sum, TRUE, NULL) == -1){
          showerror("database writing failed");
        } else {
          kbuf = NULL;
          for(j = 0; j < ezcontsize(kwords); j++){
            kbuf = ezstrcat(kbuf, kbuf ? "\t" : "", ezcontval(kwords, j), NULL);
          }
          sprintf(idstr, "K%X", i);
          if(aqdbwrite(dbname, idstr, kbuf, TRUE, NULL) == -1){
            showerror("database writing failed");
          } else {
            printf("%d: %s: summarized (%d keywords)\n", i, buf, ezcontsize(kwords));
            fflush(stdout);
          }
          free(kbuf);
        }
        free(sum);
        free(scores);
        ezdelcont(kwords);
        ezdelcont(words);
        free(str);
      }
      free(buf);
    } else {
      showerror("search for %s failed", idstr);
    }
  }
  free(ppcmd);
  if(fid > 0){
    if(aqdbreorganize(dbname) == -1) showerror("database rebuilding failed");
    t = eztime() - t;
    printf("%s: %02d:%02d:%02d elapsed\n",
           rv == 0 ? "completed" : "done", (int)(t / 3600), (int)((t / 60) % 60), (int)(t % 60));
  } else {
    showerror("nothing to do");
  }
  aqdbrelease();
}
